# ---------------------------------------------------------------------------
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ---------------------------------------------------------------------------
apiVersion: camel.apache.org/v1
kind: Kamelet
metadata:
  name: kubernetes-pods-source
  annotations:
    camel.apache.org/kamelet.support.level: "Stable"
    camel.apache.org/catalog.version: "4.10.2"
    camel.apache.org/kamelet.icon: "data:image/svg+xml;base64,[encoded data, 14584 characters]"
    camel.apache.org/provider: "Apache Software Foundation"
    camel.apache.org/kamelet.group: "Kubernetes"
    camel.apache.org/kamelet.namespace: "Cloud"
  labels:
    camel.apache.org/kamelet.type: "source"
spec:
  definition:
    title: "Kubernetes Pods Source"
    description: |-
      Consume Events from Kubernetes Pods
    required:
      - token
      - masterUrl
    type: object
    properties:
      token:
        title: Oauth Token
        description: The Auth Token to connect to Kubernetes Cluster
        type: string
        format: password
        x-descriptors:
        - urn:camel:group:credentials
      masterUrl:
        title: Kubernetes Master URL
        description: The Kubernetes Cluster Master URL
        type: string
      resourceName:
        title: Resource Name
        description: The Resource Name we want to watch
        type: string
  types:
    out:
      mediaType: application/json
  dependencies:
    - "camel:kubernetes"
    - "camel:kamelet"
    - "camel:jackson"
  template:
    from:
      uri: "kubernetes-pods://{{masterUrl}}"
      parameters:
        oauthToken: "{{token}}"
        resourceName: "{{?resourceName}}"
      steps:
      - marshal:
          json: {}
      - to: "kamelet:sink"